Surrounded Regions
DESCRIPTION (credit Leetcode.com)
Given an m x n matrix grid containing only characters 'X' and 'O', modify grid to replace all regions of 'O' that are completey surrounded by 'X' with 'X'.
A region of 'O' is surrounded by 'X' if there is no adjacent path (cells that border each other in the N, W, E, S directions) consisting of only 'O' from anywhere inside that region to the border of the board.
EXAMPLES
Input:
grid = [ ["X","X","X","X","O"], ["X","X","O","X","X"], ["X","X","O","X","O"], ["X","O","X","X","X"] ["X","O","X","X","X"] ]
Output:
[ ["X","X","X","X","O"], ["X","X","X","X","X"], ["X","X","X","X","O"], ["X","O","X","X","X"], ["X","O","X","X","X"] ]
Explanation: The region of O's at grid[1][2] and grid[2][2] is completely surrounded, so we replace them with X's. All the other "O"s are connected to the border by a path of all "O"s, so we leave them as is.
Input:
grid = [ ["O","O"], ["O","X"], ]
Output:
[ ["O", "O"], ["O", "X"] ]
Explanation: All the "O"s are connected to the border.
Run your code to see results here
Explanation
In order to solve this problem, we can first recognize that there are two types of "Os" in the grid, those that are reachable on a path of connected "O"s starting from the border of the grid, and those that are not.
The "Os" that are reachable from the border are the ones that we want to keep, while the "Os" that are not reachable from the border are the ones that we want to change to "Xs".
In order for an "O" to be reachable from the border, it must be connected to an "O" that is on the border. This means that we can start from each cell in the border of the grid and use depth-first search to find all the "Os" that are reachable from the border of the grid (by following a path of connected "Os" in the N, E, S, W directions). Whenever we find an "O" that is reachable from the border, we can change its value to "S" to mark it as safe.
After marking them as safe, we can then iterate through each cell in the grid and change the "Os" that are not marked as safe to "Xs", while also changing the "safe" cells back to "Os".
class Solution:def surrounded_regions(self, grid):if not grid:return gridrows = len(grid)cols = len(grid[0])# recursive function to find all the "O"s that are reachable# from the border and mark them as "S"def dfs(x, y):# return immediately if the cell is out of bounds or is not an "Oif x < 0 or y < 0 or x >= rows or y >= cols or grid[x][y] != 'O':returngrid[x][y] = 'S'# explore the neighboring cellsdfs(x + 1, y)dfs(x - 1, y)dfs(x, y + 1)dfs(x, y - 1)# iniitialize the dfs for the first and last columnfor i in range(rows):if grid[i][0] == 'O':dfs(i, 0)if grid[i][cols - 1] == 'O':dfs(i, cols - 1)# iniitialize the dfs for the first and last rowfor j in range(cols):if grid[0][j] == 'O':dfs(0, j)if grid[rows - 1][j] == 'O':dfs(rows - 1, j)# change the "O"s that are not marked as "S" to "X"s and the "S"s back to "O"sfor i in range(rows):for j in range(cols):if grid[i][j] == 'O':grid[i][j] = 'X'elif grid[i][j] == 'S':grid[i][j] = 'O'return grid
Keeping Track of Visited Cells
In the above solution, marking each cell as "S" also serves to keep track of the visited cells. We only make recursive calls to the neighboring cells if the current cell is an "O". This way, we avoid visiting the same cell multiple times, as a cell that was previously "O" but is now "S" will not be visited again.
Complexity Analysis
The time complexity for this approach is O(M * N), where M is the number of rows and N is the number of columns in the grid. This is because we are iterating through each cell in the grid once.
The space complexity is O(M * N), since we have to allocate space for each recursive call in the call stack, which can be at most O(M * N).
Loading comments...